import { useEffect, useRef, useState } from "react";
import { AsyncCall, initialStateAsyncCall } from "./AsyncCall";
export const useAsyncCall = (params, executeFn, config) => {
  const [, setState] = useState(initialStateAsyncCall);
  const AsyncCallRef = useRef(new AsyncCall(params.params$, executeFn, config, null, setState));
  const asyncCall = AsyncCallRef.current;
  useEffect(() => {
    asyncCall.init();
    return () => {
      asyncCall.destroy$.next();
      asyncCall.destroy$.complete();
    };
  }, [asyncCall]);
  const status = asyncCall.newState.status;
  return {
    data: status.data,
    error: status.error,
    isLoading: status.status === 'PROCESSING',
    isSuccess: status.status === 'SUCCESS',
    execute: asyncCall.execute,
    reload: asyncCall.reload,
    status: status.status,
    getState: asyncCall.getState,
    isError: status.status === 'ERROR'
  };
};