"use strict";

exports.__esModule = true;
exports.useAsyncCall = void 0;

var _react = require("react");

var _AsyncCall = require("./AsyncCall");

const useAsyncCall = (params, executeFn, config) => {
  const [, setState] = (0, _react.useState)(_AsyncCall.initialStateAsyncCall);
  const AsyncCallRef = (0, _react.useRef)(new _AsyncCall.AsyncCall(params.params$, executeFn, config, null, setState));
  const asyncCall = AsyncCallRef.current;
  (0, _react.useEffect)(() => {
    asyncCall.init();
    return () => {
      asyncCall.destroy$.next();
      asyncCall.destroy$.complete();
    };
  }, [asyncCall]);
  const status = asyncCall.newState.status;
  return {
    data: status.data,
    error: status.error,
    isLoading: status.status === 'PROCESSING',
    isSuccess: status.status === 'SUCCESS',
    execute: asyncCall.execute,
    reload: asyncCall.reload,
    status: status.status,
    getState: asyncCall.getState,
    isError: status.status === 'ERROR'
  };
};

exports.useAsyncCall = useAsyncCall;